"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

var _sleepPromise = _interopRequireDefault(require("sleep-promise"));

var _terminal = _interopRequireDefault(require("terminal.js"));

var _keyboard = _interopRequireDefault(require("../../utils/keyboard"));

var _char = require("../../utils/char");

var _config = _interopRequireDefault(require("./config"));

var Bot =
/*#__PURE__*/
function (_EventEmitter) {
  (0, _inherits2.default)(Bot, _EventEmitter);

  function Bot(config) {
    var _this;

    (0, _classCallCheck2.default)(this, Bot);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Bot).call(this));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "getLine", function (n) {
      return _this._term.state.getLine(n);
    });
    config = (0, _objectSpread2.default)({}, _config.default, config);
    _this._term = new _terminal.default(config.terminal);
    _this._state = (0, _objectSpread2.default)({}, Bot.initialState);

    _this._term.state.setMode('stringWidth', 'dbcs');

    var Socket;

    switch (config.protocol.toLowerCase()) {
      case 'websocket':
      case 'ws':
      case 'wss':
        Socket = require("../../core/socket").default;
        break;

      case 'telnet':
      case 'ssh':
      default:
        Socket = null;
    }

    if (Socket === null) {
      throw "Invalid protocol: ".concat(config.protocol);
    }

    var socket = new Socket(config);
    socket.connect();
    Bot.forwardEvents.forEach(function (e) {
      socket.on(e, _this.emit.bind((0, _assertThisInitialized2.default)(_this), e));
    });
    socket.on('connect', function () {
      var _this2;

      _this._state.connect = true;

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      (_this2 = _this).emit.apply(_this2, ['connect'].concat(args));

      _this.emit('stateChange', _this.state);
    }).on('disconnect', function (closeEvent) {
      var _this3;

      _this._state.connect = false;

      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      (_this3 = _this).emit.apply(_this3, ['disconnect', closeEvent].concat(args));

      _this.emit('stateChange', _this.state);
    }).on('message', function (msg) {
      _this._term.write(msg);

      _this.emit('redraw', _this._term.toString());
    }).on('error', function (err) {
      console.log(err);
    });
    _this.socket = socket;
    _this.config = config;
    return _this;
  }

  (0, _createClass2.default)(Bot, [{
    key: "getLines",
    value: function () {
      var _getLines = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var getLine, lines, i, lastLine, _i, j;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                getLine = this.getLine;
                lines = [];
                lines.push(getLine(0).str);

              case 3:
                if (getLine(23).str.includes("100%")) {
                  _context.next = 9;
                  break;
                }

                for (i = 1; i < 23; i++) {
                  lines.push(getLine(i).str);
                }

                _context.next = 7;
                return this.send(_keyboard.default.PgDown);

              case 7:
                _context.next = 3;
                break;

              case 9:
                lastLine = lines[lines.length - 1];
                _i = 0;

              case 11:
                if (!(_i < 23)) {
                  _context.next = 18;
                  break;
                }

                if (!(getLine(_i).str == lastLine)) {
                  _context.next = 15;
                  break;
                }

                for (j = _i + 1; j < 23; j++) {
                  lines.push(getLine(j).str);
                }

                return _context.abrupt("break", 18);

              case 15:
                _i++;
                _context.next = 11;
                break;

              case 18:
                while (lines.length > 0 && lines[lines.length - 1].length == 0) {
                  lines.pop();
                }

                return _context.abrupt("return", lines);

              case 20:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getLines() {
        return _getLines.apply(this, arguments);
      }

      return getLines;
    }()
  }, {
    key: "send",
    value: function () {
      var _send = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(msg) {
        var _this4 = this;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.config.preventIdle && this.preventIdle();
                return _context2.abrupt("return", new Promise(function (resolve) {
                  if (_this4.state.connect) {
                    _this4.socket.send(msg);

                    _this4.once('message', function (msg) {
                      resolve(msg);
                    });
                  }
                }));

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function send(_x) {
        return _send.apply(this, arguments);
      }

      return send;
    }()
  }, {
    key: "preventIdle",
    value: function preventIdle() {
      var _this5 = this;

      var timeout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 60;
      clearTimeout(this.preventIdleHandler);

      if (this.state.login) {
        this.preventIdleHandler = setTimeout(function () {
          _this5.send("".concat(_keyboard.default.CtrlU).concat(_keyboard.default.ArrowLeft));
        }, timeout * 1000);
      }
    }
  }, {
    key: "login",
    value: function () {
      var _login = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(username, password) {
        var ret, state;
        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!this.state.login) {
                  _context3.next = 2;
                  break;
                }

                return _context3.abrupt("return");

              case 2:
                username = username.replace(/,/g, '');
                _context3.next = 5;
                return this.send("".concat(username, ",").concat(_keyboard.default.Enter).concat(password).concat(_keyboard.default.Enter));

              case 5:
                _context3.next = 7;
                return this._checkLogin();

              case 7:
                _context3.t0 = ret = _context3.sent;

                if (!(_context3.t0 === null)) {
                  _context3.next = 13;
                  break;
                }

                _context3.next = 11;
                return (0, _sleepPromise.default)(400);

              case 11:
                _context3.next = 5;
                break;

              case 13:
                if (ret) {
                  state = this._state;
                  state.login = true;
                  state.position = {
                    boardname: ""
                  };
                  this.emit('stateChange', this.state);
                }

                return _context3.abrupt("return", ret);

              case 15:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function login(_x2, _x3) {
        return _login.apply(this, arguments);
      }

      return login;
    }()
  }, {
    key: "logout",
    value: function () {
      var _logout = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4() {
        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (this.state.login) {
                  _context4.next = 2;
                  break;
                }

                return _context4.abrupt("return");

              case 2:
                _context4.next = 4;
                return this.send("G".concat(_keyboard.default.Enter, "Y").concat(_keyboard.default.Enter.repeat(2)));

              case 4:
                this._state.login = false;
                this.emit('stateChange', this.state);
                return _context4.abrupt("return", true);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function logout() {
        return _logout.apply(this, arguments);
      }

      return logout;
    }()
  }, {
    key: "_checkLogin",
    value: function () {
      var _checkLogin2 = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5() {
        var getLine;
        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                getLine = this.getLine;

                if (!getLine(21).str.includes("密碼不對或無此帳號")) {
                  _context5.next = 6;
                  break;
                }

                this.emit('login.failed');
                return _context5.abrupt("return", false);

              case 6:
                if (!(getLine(22).str + getLine(23).str).toLowerCase().includes("y/n")) {
                  _context5.next = 11;
                  break;
                }

                _context5.next = 9;
                return this.send("y".concat(_keyboard.default.Enter));

              case 9:
                _context5.next = 33;
                break;

              case 11:
                if (!getLine(23).str.includes("請勿頻繁登入以免造成系統過度負荷")) {
                  _context5.next = 16;
                  break;
                }

                _context5.next = 14;
                return this.send("".concat(_keyboard.default.Enter));

              case 14:
                _context5.next = 33;
                break;

              case 16:
                if (!getLine(23).str.includes("按任意鍵繼續")) {
                  _context5.next = 21;
                  break;
                }

                _context5.next = 19;
                return this.send("".concat(_keyboard.default.Enter));

              case 19:
                _context5.next = 33;
                break;

              case 21:
                if (!getLine(23).str.includes("您要刪除以上錯誤嘗試的記錄嗎")) {
                  _context5.next = 26;
                  break;
                }

                _context5.next = 24;
                return this.send("y".concat(_keyboard.default.Enter));

              case 24:
                _context5.next = 33;
                break;

              case 26:
                if (!getLine(23).str.includes("我是")) {
                  _context5.next = 31;
                  break;
                }

                this.emit('login.success');
                return _context5.abrupt("return", true);

              case 31:
                _context5.next = 33;
                return this.send("q");

              case 33:
                return _context5.abrupt("return", null);

              case 34:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function _checkLogin() {
        return _checkLogin2.apply(this, arguments);
      }

      return _checkLogin;
    }()
  }, {
    key: "_checkArticleWithHeader",
    value: function _checkArticleWithHeader() {
      var authorArea = (0, _char.substrWidth)('dbcs', this.getLine(0).str, 0, 6).trim();
      return authorArea === "作者";
    }
  }, {
    key: "getArticles",
    value: function () {
      var _getArticles = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee6(boardname) {
        var offset,
            getLine,
            articles,
            i,
            line,
            article,
            _i2,
            _i3,
            _args6 = arguments;

        return _regenerator.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                offset = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : 0;
                _context6.next = 3;
                return this.enterBoard(boardname);

              case 3:
                offset |= 0;

                if (!(offset > 0)) {
                  _context6.next = 8;
                  break;
                }

                offset = Math.max(offset - 9, 1);
                _context6.next = 8;
                return this.send("".concat(_keyboard.default.End).concat(_keyboard.default.End).concat(offset).concat(_keyboard.default.Enter));

              case 8:
                getLine = this.getLine;
                articles = [];

                for (i = 3; i <= 22; i++) {
                  line = getLine(i).str;
                  article = {
                    sn: (0, _char.substrWidth)('dbcs', line, 1, 7).trim() | 0,
                    push: (0, _char.substrWidth)('dbcs', line, 9, 2).trim(),
                    date: (0, _char.substrWidth)('dbcs', line, 11, 5).trim(),
                    author: (0, _char.substrWidth)('dbcs', line, 17, 12).trim(),
                    status: (0, _char.substrWidth)('dbcs', line, 30, 2).trim(),
                    title: (0, _char.substrWidth)('dbcs', line, 32).trim(),
                    fixed: (0, _char.substrWidth)('dbcs', line, 1, 7).trim().includes('★')
                  };
                  articles.push(article);
                } // fix sn


                if (!(articles.length >= 2 && articles[0].sn === 0)) {
                  _context6.next = 20;
                  break;
                }

                _i2 = 1;

              case 13:
                if (!(_i2 < articles.length)) {
                  _context6.next = 20;
                  break;
                }

                if (!(articles[_i2].sn !== 0)) {
                  _context6.next = 17;
                  break;
                }

                articles[0].sn = articles[_i2].sn - _i2;
                return _context6.abrupt("break", 20);

              case 17:
                _i2++;
                _context6.next = 13;
                break;

              case 20:
                for (_i3 = 1; _i3 < articles.length; _i3++) {
                  articles[_i3].sn = articles[_i3 - 1].sn + 1;
                }

                _context6.next = 23;
                return this.enterIndex();

              case 23:
                return _context6.abrupt("return", articles.reverse());

              case 24:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getArticles(_x4) {
        return _getArticles.apply(this, arguments);
      }

      return getArticles;
    }()
  }, {
    key: "getArticle",
    value: function () {
      var _getArticle = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee7(boardname, sn) {
        var getLine, hasHeader, article;
        return _regenerator.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return this.enterBoard(boardname);

              case 2:
                getLine = this.getLine;
                _context7.next = 5;
                return this.send("".concat(sn).concat(_keyboard.default.Enter).concat(_keyboard.default.Enter));

              case 5:
                hasHeader = this._checkArticleWithHeader();
                article = {
                  sn: sn,
                  author: "",
                  title: "",
                  timestamp: "",
                  lines: []
                };

                if (this._checkArticleWithHeader()) {
                  article.author = (0, _char.substrWidth)('dbcs', getLine(0).str, 7, 50).trim();
                  article.title = (0, _char.substrWidth)('dbcs', getLine(1).str, 7).trim();
                  article.timestamp = (0, _char.substrWidth)('dbcs', getLine(2).str, 7).trim();
                }

                _context7.next = 10;
                return this.getLines();

              case 10:
                article.lines = _context7.sent;
                _context7.next = 13;
                return this.enterIndex();

              case 13:
                return _context7.abrupt("return", article);

              case 14:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getArticle(_x5, _x6) {
        return _getArticle.apply(this, arguments);
      }

      return getArticle;
    }()
  }, {
    key: "getFavorite",
    value: function () {
      var _getFavorite = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee8() {
        var offsets,
            getLine,
            favorites,
            i,
            line,
            favorite,
            _args8 = arguments;
        return _regenerator.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                offsets = _args8.length > 0 && _args8[0] !== undefined ? _args8[0] : [];

                if (typeof offsets === "string") {
                  offsets |= 0;
                }

                if (typeof offsets === "number") {
                  offsets = [offsets];
                }

                _context8.next = 5;
                return this.enterFavorite(offsets);

              case 5:
                getLine = this.getLine;
                favorites = [];
                i = 3;

              case 8:
                if (!(i < 23)) {
                  _context8.next = 25;
                  break;
                }

                line = getLine(i).str;

                if (!(line.trim() === '')) {
                  _context8.next = 12;
                  break;
                }

                return _context8.abrupt("break", 25);

              case 12:
                favorite = {
                  bn: (0, _char.substrWidth)('dbcs', line, 3, 4).trim() | 0,
                  read: (0, _char.substrWidth)('dbcs', line, 8, 2).trim() === '',
                  boardname: (0, _char.substrWidth)('dbcs', line, 10, 12).trim(),
                  category: (0, _char.substrWidth)('dbcs', line, 23, 4).trim(),
                  title: (0, _char.substrWidth)('dbcs', line, 30, 31),
                  users: (0, _char.substrWidth)('dbcs', line, 62, 5).trim(),
                  admin: (0, _char.substrWidth)('dbcs', line, 67).trim(),
                  folder: false,
                  divider: false
                };
                _context8.t0 = favorite.boardname;
                _context8.next = _context8.t0 === 'MyFavFolder' ? 16 : _context8.t0 === '------------' ? 18 : 20;
                break;

              case 16:
                favorite = (0, _objectSpread2.default)({}, favorite, {
                  title: (0, _char.substrWidth)('dbcs', line, 30),
                  users: '',
                  admin: '',
                  folder: true
                });
                return _context8.abrupt("break", 21);

              case 18:
                favorite = (0, _objectSpread2.default)({}, favorite, {
                  title: (0, _char.substrWidth)('dbcs', line, 30),
                  users: '',
                  admin: '',
                  divider: true
                });
                return _context8.abrupt("break", 21);

              case 20:
                return _context8.abrupt("break", 21);

              case 21:
                favorites.push(favorite);

              case 22:
                i++;
                _context8.next = 8;
                break;

              case 25:
                _context8.next = 27;
                return this.enterIndex();

              case 27:
                return _context8.abrupt("return", favorites);

              case 28:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function getFavorite() {
        return _getFavorite.apply(this, arguments);
      }

      return getFavorite;
    }()
  }, {
    key: "getMails",
    value: function () {
      var _getMails = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee9() {
        var offset,
            getLine,
            mails,
            i,
            line,
            mail,
            _args9 = arguments;
        return _regenerator.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                offset = _args9.length > 0 && _args9[0] !== undefined ? _args9[0] : 0;
                _context9.next = 3;
                return this.enterMail();

              case 3:
                offset |= 0;

                if (!(offset > 0)) {
                  _context9.next = 8;
                  break;
                }

                offset = Math.max(offset - 9, 1);
                _context9.next = 8;
                return this.send("".concat(_keyboard.default.End).concat(_keyboard.default.End).concat(offset).concat(_keyboard.default.Enter));

              case 8:
                getLine = this.getLine;
                mails = [];

                for (i = 3; i <= 22; i++) {
                  line = getLine(i).str;
                  mail = {
                    sn: (0, _char.substrWidth)('dbcs', line, 1, 5).trim() | 0,
                    date: (0, _char.substrWidth)('dbcs', line, 9, 5).trim(),
                    author: (0, _char.substrWidth)('dbcs', line, 15, 12).trim(),
                    status: (0, _char.substrWidth)('dbcs', line, 30, 2).trim(),
                    title: (0, _char.substrWidth)('dbcs', line, 33).trim()
                  };
                  mails.push(mail);
                }

                _context9.next = 13;
                return this.enterIndex();

              case 13:
                return _context9.abrupt("return", mails.reverse());

              case 14:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function getMails() {
        return _getMails.apply(this, arguments);
      }

      return getMails;
    }()
  }, {
    key: "getMail",
    value: function () {
      var _getMail = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee10(sn) {
        var getLine, hasHeader, mail;
        return _regenerator.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this.enterMail();

              case 2:
                getLine = this.getLine;
                _context10.next = 5;
                return this.send("".concat(sn).concat(_keyboard.default.Enter).concat(_keyboard.default.Enter));

              case 5:
                hasHeader = this._checkArticleWithHeader();
                mail = {
                  sn: sn,
                  author: "",
                  title: "",
                  timestamp: "",
                  lines: []
                };

                if (this._checkArticleWithHeader()) {
                  mail.author = (0, _char.substrWidth)('dbcs', getLine(0).str, 7, 50).trim();
                  mail.title = (0, _char.substrWidth)('dbcs', getLine(1).str, 7).trim();
                  mail.timestamp = (0, _char.substrWidth)('dbcs', getLine(2).str, 7).trim();
                }

                _context10.next = 10;
                return this.getLines();

              case 10:
                mail.lines = _context10.sent;
                _context10.next = 13;
                return this.enterIndex();

              case 13:
                return _context10.abrupt("return", mail);

              case 14:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function getMail(_x7) {
        return _getMail.apply(this, arguments);
      }

      return getMail;
    }()
  }, {
    key: "enterIndex",
    value: function () {
      var _enterIndex = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee11() {
        return _regenerator.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return this.send("".concat(_keyboard.default.ArrowLeft.repeat(10)));

              case 2:
                return _context11.abrupt("return", true);

              case 3:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function enterIndex() {
        return _enterIndex.apply(this, arguments);
      }

      return enterIndex;
    }()
  }, {
    key: "enterBoard",
    value: function () {
      var _enterBoard = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee12(boardname) {
        var getLine;
        return _regenerator.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.send("s".concat(boardname).concat(_keyboard.default.Enter, " ").concat(_keyboard.default.Home).concat(_keyboard.default.End));

              case 2:
                boardname = boardname.toLowerCase();
                getLine = this.getLine;

                if (!getLine(23).str.includes("按任意鍵繼續")) {
                  _context12.next = 7;
                  break;
                }

                _context12.next = 7;
                return this.send(" ");

              case 7:
                if (!getLine(0).str.toLowerCase().includes("".concat(boardname))) {
                  _context12.next = 11;
                  break;
                }

                this._state.position.boardname = boardname;
                this.emit('stateChange', this.state);
                return _context12.abrupt("return", true);

              case 11:
                return _context12.abrupt("return", false);

              case 12:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function enterBoard(_x8) {
        return _enterBoard.apply(this, arguments);
      }

      return enterBoard;
    }()
  }, {
    key: "enterFavorite",
    value: function () {
      var _enterFavorite = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee13() {
        var offsets,
            enterOffsetMessage,
            _args13 = arguments;
        return _regenerator.default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                offsets = _args13.length > 0 && _args13[0] !== undefined ? _args13[0] : [];
                enterOffsetMessage = offsets.map(function (offset) {
                  return "".concat(offset).concat(_keyboard.default.Enter.repeat(2));
                }).join();
                _context13.next = 4;
                return this.send("F".concat(_keyboard.default.Enter).concat(enterOffsetMessage));

              case 4:
                return _context13.abrupt("return", true);

              case 5:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function enterFavorite() {
        return _enterFavorite.apply(this, arguments);
      }

      return enterFavorite;
    }()
  }, {
    key: "enterMail",
    value: function () {
      var _enterMail = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee14() {
        return _regenerator.default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                _context14.next = 2;
                return this.send("M".concat(_keyboard.default.Enter, "R").concat(_keyboard.default.Enter).concat(_keyboard.default.Home).concat(_keyboard.default.End));

              case 2:
                return _context14.abrupt("return", true);

              case 3:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function enterMail() {
        return _enterMail.apply(this, arguments);
      }

      return enterMail;
    }()
  }, {
    key: "state",
    get: function get() {
      return (0, _objectSpread2.default)({}, this._state);
    }
  }]);
  return Bot;
}(_eventemitter.default);

(0, _defineProperty2.default)(Bot, "initialState", {
  connect: false,
  login: false
});
(0, _defineProperty2.default)(Bot, "forwardEvents", ['message', 'error']);
var _default = Bot;
exports.default = _default;